/* $Id:*/

/**
 * @file qtc.js
 * The script implements the client-side functions to realize the QTChat chat function.
 */

var windowFocus = true;
var un; // username
var urn; // userrealname
var chatHeartbeatCount = 0;
var minChatHeartbeat = 2000;
var maxChatHeartbeat = 30000;
var chatHeartbeatTime = minChatHeartbeat;
var heartbeatFriendlistTime = minChatHeartbeat;
var originalTitle;
var blinkOrder = 0;
var cookieName = 'qtc_window';

var date = new Date();

var chatboxFocus = new Array();
var newMessages = new Array();
var newMessagesWin = new Array();
var chatBoxes = new Array();
var chatCookies = new Array();

$(document).ready(function() {
 originalTitle = document.title;

 minChatHeartbeat = Drupal.settings.qtc.minHeartbeat;
 maxChatHeartbeat = Drupal.settings.qtc.minHeartbeat;
 chatHeartbeatTime = minChatHeartbeat;
 heartbeatFriendlistTime = Drupal.settings.qtc.friendHeartbeat;

 startChatSession();

 loadChatBarFunc();

 $([window, document]).blur(function() {
  windowFocus = false;
 }).focus(function() {
  windowFocus = true;
  document.title = originalTitle;
 });
});

function loadChatBarFunc() {
 $('div#qtc-bar-onoffline').click(function() {
  $('div#qtc-barfly').toggleClass('qtc-barfly-apps-show').toggle();
 });
 $('div#qtc-barfly-title').click(function() {
  $('div#qtc-barfly').toggleClass('qtc-barfly-apps-show').toggle();
 });
 $('div.qtc-barfly-tools').click(function() {
  $('div#qtc-barfly-options').toggleClass('qtc-barfly-options-show').toggle();
 });
}

function restructureChatBoxes() {
 align = 0;
 for (x in chatBoxes) {
  if ($("div#chatbox_"+chatBoxes[x]).css('display') != 'none') {
   if (align == 0) {
    if (Drupal.settings.qtc.chatBar) {
     $("div#chatbox_"+chatBoxes[x]).css({'right': '185px', 'bottom': '0'});
    }
    else {
     $("div#chatbox_"+chatBoxes[x]).css({'right': '20px', 'bottom': '0'});
    }
   }
   else {
    if (Drupal.settings.qtc.chatBar) {
     width = (align)*(245)+19+165;
    }
    else {
     width = (align)*(245+7)+20;
    }

    $("div#chatbox_"+chatBoxes[x]).css({'right': width+'px', 'bottom': '0'});
   }
   align++;
  }
 }
}

function chatWith(t_id,chatuser,name) {
 createChatBox(t_id,chatuser,name);
 $("div#chatbox_"+t_id+" .chatboxtextarea").focus();
}

function emptyHistory(t_id) {
 $('div#chatbox_'+t_id+' .chatboxcontent .chatboxmessage').remove();
 $.post(Drupal.settings.qtc.baseUrl + "/qtc/history/empty");
}

function createChatBox(t_id,t_un,t_name,m,t,minimizeChatBox) {
 if ($("div#chatbox_"+t_id).length > 0) {
  if ($("div#chatbox_"+t_id+".collapsed")) {
   $('div#chatbox_'+t_id).removeClass('collapsed');
   $("div#chatbox_"+t_id).css('display', 'block');
   $('div#chatbox_'+t_id+' .chatboxsubhead').css('display', 'block');
   $('div#chatbox_'+t_id+' .chatboxcontent').css('display', 'block');
   $('div#chatbox_'+t_id+' .chatboxinput').css('display', 'block');
   restructureChatBoxes();
  }
  $("div#chatbox_"+t_id+" .chatboxtextarea").focus();
  return;
 }

 $.ajax({
  type: "POST",
  url: Drupal.settings.qtc.baseUrl + "/qtc/ajax/data",
  data: "t_id="+t_id,
  cache: false,
  dataType: "json",
  success: function(data) {
   avatar = data.avatar;
   var m_time;
   var status_online = '';
   var status_offline = '';
   var online_toggle = '';
   var offline_toggle = '';
   var chatboxClass = 'chatbox';

   if (data.online == 1) {
    online_toggle = 'block';
    offline_toggle = 'none';
   }
   else {
    online_toggle = 'none';
    offline_toggle = 'block';
   }
   status_online = '<span id="qtc-bar-user-stat-online_'+t_id+'" style="display: '+online_toggle+';" class="user-stat-online chat-message">'+Drupal.t('online')+'</span>';
   status_offline = '<span id="qtc-bar-user-stat-offline_'+t_id+'" style="display: '+offline_toggle+';" class="user-stat-offline chat-message">'+Drupal.t('offline')+'</span>';

   if (Drupal.settings.qtc.chatBar) {
    chatboxClass = 'chatbox-bar-on chatbox-bar';
   }
   else {
    chatboxClass = 'chatbox-bar-off chatbox-bar';
   }

   $("<div />")
    .attr({id: "chatbox_"+t_id, tid: t_id})
    .addClass(chatboxClass)      
    .html('<div class="chatboxhead">  <div class="chatbox-user-show">'+data.path+'</div>   <a class="chatbox-toggler" title="'+ Drupal.t('Hide/unhide') +'" href="javascript:void(0)" onclick="javascript:toggleChatBoxGrowth(\''+t_id+'\', \''+t_un+'\')"><div class="chatbox-hide">  <div class="chatbox-toggle">-</div></div></a>         <div class="chatboxoptions"><a class="chatbox-close" title="'+ Drupal.t('Close') +'" href="javascript:void(0)" onclick="javascript:closeChatBox(\''+t_id+'\', \''+t_un+'\')"> X </a></div></div><div style="display: none;" class="message-incoming">New message</div><div class="chatboxsubhead clear-block"><span class="chat-avatar">'+avatar+'</span>'+status_online+''+status_offline+'<a href="'+Drupal.settings.qtc.baseUrl+'/qtc/history/show/'+t_id+'?popup=1" onclick="var w=window.open(this.href, \'chat_history_window\', \'width=400,height=500,scrollbars,resizable\'); w.focus(); return false;" class="history-show-link" title="'+Drupal.t('Chat history')+'"><span>'+Drupal.t('Chat history')+'</span></a> <a href="javascript:void(0)" onclick="javascript:emptyHistory(\''+t_id+'\')" class="history-empty-link" title="'+Drupal.t('Empty history')+'"><span>'+Drupal.t('Empty history')+'</span></a> <a href="javascript:void(0)" onclick="javascript:toggleTime()" class="messagetime-toggle" ts="show" title="'+Drupal.t('Show/hide time')+'"><span>'+Drupal.t('Show/hide time')+'</span></a></div><div class="chatboxcontent-wrapper"><div class="chatboxcontent"></div><div class="chatboxinput clear-block"><div id="chatbox-inputimage"></div><div id="chatbox-inputarea"><textarea class="chatboxtextarea" onkeydown="javascript:return checkChatBoxInputKey(event,this,\''+t_id+'\', \''+t_un+'\', \''+t_name+'\');"></textarea></div></div></div>')
    .appendTo($("body"));

   if (m && typeof(m) != 'object') {
    $("div#chatbox_"+t_id+" .chatboxcontent").append('<div class="chatboxmessage"><span class="chatboxmessagefrom">'+t_name+':&nbsp;&nbsp;</span><span class="chatboxmessagecontent">'+m+'</span>&nbsp;<span class="chatboxmessagetime">'+t+'</span></div>');
   }
   else if (m && typeof(m) == 'object') {
    for (i in m) {
     if (m[i].i == t_id) {
      m[i].fn = Drupal.t('Me');
     }
     m_time = messageDate('short', m[i].t);
     $("div#chatbox_"+t_id+" .chatboxcontent").append('<div class="chatboxmessage"><span class="chatboxmessagefrom">'+m[i].fn+':&nbsp;&nbsp;</span><span class="chatboxmessagecontent">'+m[i].m+'</span>&nbsp;<span class="chatboxmessagetime">'+m_time+'</span></div>');
    }
   }

   if (data.online == 1) {
    $('div#chatbox_'+t_id).addClass('chatbox-user-online');
   }
   else {
    $('div#chatbox_'+t_id).addClass('chatbox-user-offline');
    $("div#chatbox_"+t_id+" .chatboxcontent").append('<div class="chatboxmessage-offline"><span class="chatboxmessagefrom">'+Drupal.t('Chat')+':&nbsp;&nbsp;</span><span class="chatboxmessagecontent">'+Drupal.t('User is offline.')+'</span>&nbsp;<span class="chatboxmessagetime">'+messageDate()+'</span></div>');
   }

   $("div#chatbox_"+t_id).css('bottom', '0px');

   chatBoxeslength = 0;

   for (x in chatBoxes) {
    if ($("div#chatbox_"+chatBoxes[x]).css('display') != 'none') {
     chatBoxeslength++;
    }
   }

   if (chatBoxeslength == 0) {
    if (Drupal.settings.qtc.chatBar) {
     $("div#chatbox_"+t_id).css({'right': '184px', 'bottom': '0'});
   }
   else {
    $("div#chatbox_"+t_id).css({'right': '20px', 'bottom': '0'});
   }
  }
  else {
   if (Drupal.settings.qtc.chatBar) {
    width = (chatBoxeslength)*(245)+19+165;
   }
   else {
    width = (chatBoxeslength)*(245+7)+20;
   }
   $("div#chatbox_"+t_id).css({'right': width+'px', 'bottom': '0'});
  }

  chatBoxes.push(t_id);
  chatBoxeslength += 1;

  if (minimizeChatBox == 1) {
   minimizedChatBoxes = new Array();
   if ($.cookie('chatbox_minimized')) {
    minimizedChatBoxes = $.cookie('chatbox_minimized').split(/\|/);
   }
   minimize = 0;
   for (j=0;j<minimizedChatBoxes.length;j++) {
    if (minimizedChatBoxes[j] == t_id) {
     minimize = 1;
    }
   }
   if (minimize == 1) {
    $('div#chatbox_'+t_id).addClass('collapsed');
    $('div#chatbox_'+t_id+' .chatboxsubhead').css('display', 'none');
    $('div#chatbox_'+t_id+' .chatboxcontent').css('display', 'none');
    $('div#chatbox_'+t_id+' .chatboxinput').css('display', 'none');
   }
  }

  chatBoxes.sort(numComparisonAsc);

  chatboxFocus[t_id] = false;

  $("div#chatbox_"+t_id+" .chatboxtextarea").blur(function() {
   chatboxFocus[t_id] = false;
   //$("div#chatbox_"+t_id+" .chatboxtextarea").removeClass('chatboxtextareaselected');
  }).focus(function() {
   chatboxFocus[t_id] = true;
   newMessages[t_id] = false;
   //$('div#chatbox_'+t_id+' .chatboxhead').removeClass('chatboxblink');
   $("div#chatbox_"+t_id+" .chatboxtextarea").addClass('chatboxtextareaselected');
  });

  $("div#chatbox_"+t_id).click(function() {
   if ($('div#chatbox_'+t_id+' .chatboxcontent').css('display') != 'none' && $('div#chatbox_'+t_id+'.chatbox-user-online').css('')) {
    $("div#chatbox_"+t_id+" .chatboxtextarea").focus();
   }
  });

  $("div#chatbox_"+t_id).show();

  var elem = $("div#chatbox_"+t_id+" .chatboxcontent");
  if (elem[0]) {
   $("div#chatbox_"+t_id+" .chatboxcontent").scrollTop($("#chatbox_"+t_id+" .chatboxcontent")[0].scrollHeight);
  }
 }});
}

function chatHeartbeat(){
 var itemsfound = 0;

 if (windowFocus == false) {
  var blinkNumber = 0;
  var titleChanged = 0;
  for (x in newMessagesWin) {
   if (newMessagesWin[x] == true) {
    ++blinkNumber;
    if (blinkNumber >= blinkOrder) {
     document.title = x+' '+Drupal.t('says ...');
     titleChanged = 1;
     break;
    }
   }
  }

  if (titleChanged == 0) {
   document.title = originalTitle;
   blinkOrder = 0;
  }
  else {
   ++blinkOrder;
  }
 }
 else {
  for (x in newMessagesWin) {
   newMessagesWin[x] = false;
  }
 }

 for (x in newMessages) {
  if (newMessages[x] == true) {
   if (chatboxFocus[x] == false) {
    // FIXME: Add toggle all or none policy, otherwise it looks funny.
    $('div#chatbox_'+x+' .chatboxhead').toggleClass('chatboxblink');
   }
  }
 }

 $.ajax({
  type: "POST",
  url: Drupal.settings.qtc.baseUrl + "/qtc/ajax/heartbeat",
  data: "t_id="+Drupal.settings.qtc.uid,
  cache: false,
  dataType: "json",
  success: function(data) {
   $.each(data.items, function(i,item) {
    if (i > 0) {
     return ;
    }

    if (item) { // Fix strange IE bug.
     t_un = item.f;
     t_id = item.i;

     if ($("div#chatbox_"+t_id).length <= 0) {
      createChatBox(t_id,t_un,item.fn,item.m,item.t);
     }
     if ($("div#chatbox_"+t_id).css('display') == 'none') {
      $("div#chatbox_"+t_id).css('display', 'block');
      restructureChatBoxes();
     }

     if (item.s == 1) {
      item.f = un;
     }

     if (item.s == 2) {
      $("div#chatbox_"+t_id+" .chatboxcontent").append('<div class="chatboxmessage"><span class="chatboxinfo">'+item.m+'</span></div>');
     }
     else {
      newMessages[item.fn] = true;
      newMessagesWin[item.fn] = true;
      $("div#chatbox_"+t_id+" .chatboxcontent").append('<div class="chatboxmessage"><span class="chatboxmessagefrom">'+item.fn+':&nbsp;&nbsp;</span><span class="chatboxmessagecontent">'+item.m+'</span>&nbsp;<span class="chatboxmessagetime">'+item.t+'</span></div>');

      if ($('div#chatbox_'+t_id+' .chatboxcontent').css('display') == 'none') {
       $('div#chatbox_'+t_id+' .message-incoming').show();
       $('div#chatbox_'+t_id+' .chatbox-hide').click( function() {
        $('div#chatbox_'+t_id+' .message-incoming').hide();
       });
      }
     }
     var elem = $("div#chatbox_"+t_id+" .chatboxcontent");
     if (elem[0]) {
      $("div#chatbox_"+t_id+" .chatboxcontent").scrollTop($("div#chatbox_"+t_id+" .chatboxcontent")[0].scrollHeight);
     }
          
     itemsfound += 1;
    }
    ++i;
   });

   chatHeartbeatCount++;

   if (itemsfound > 0) {
    chatHeartbeatTime = minChatHeartbeat;
    chatHeartbeatCount = 1;
   }
   else if (chatHeartbeatCount >= Drupal.settings.qtc.heartbeat_1) {
    chatHeartbeatTime *= 3;
    chatHeartbeatCount = 1;
   }
   else if (chatHeartbeatCount >= Drupal.settings.qtc.heartbeat_2) {
    chatHeartbeatTime *= 4;
    chatHeartbeatCount = 1;
    if (chatHeartbeatTime > maxChatHeartbeat) {
     chatHeartbeatTime = maxChatHeartbeat;
    }
   }

   setTimeout('chatHeartbeat();', chatHeartbeatTime);
 }});
}

function chatHeartbeatFriendlist(){
 var onlineBoxes = new Array();
 // Get open chat boxes.
 var boxes = $('div.chatbox-bar');
 var openBoxes = new Array();
 $.each(boxes, function(x,item) {
  var box = item.id;
  var tid = box.substr(8);
  openBoxes[x] = tid;
 });

 var inviteTitle = Drupal.t('Chat with user');
 if (Drupal.settings.qtc.invite_title == 2) {
  inviteTitle = Drupal.t('Invite to chat');
 }
 if (Drupal.settings.qtc.invite_title == 3) {
  inviteTitle = Drupal.t('Chat');
 }

 var dataGet = false;
 if (!Drupal.settings.qtc.os_variant || Drupal.settings.qtc.os_variant == 0 || Drupal.settings.qtc.friend_m == 0) {
  dataGet = "data_get="+openBoxes;
 }

 var friends = '';
  $.ajax({
  type: "POST",
  url: Drupal.settings.qtc.baseUrl + "/qtc/ajax/heartbeat-userdata",
  data: dataGet,
  cache: false,
  dataType: "json",
  success: function(data) {
   $.each(data.items, function(i,item) {
    if (item) {
     onlineBoxes[i] = i;
     friends += '<a href="javascript:void(0)" title="'+inviteTitle+'" onclick="javascript:chatWith(\''+i+'\', \''+item.name+'\', \''+item.realname+'\')" class="qtc-chat-invite" style="display: block;">'+item.name+'</a>';
    }
   });

   if (data.count == 0) {
    friends = '<span id="qtc-friends-empty">'+Drupal.t('No online friends.')+'</span>';
   }
   // Height: 18px * 4 = 72px; reduce with 4px padding = 68px.
   if (data.count > 4) {
    $('div#qtc-barfly-friends-list-wrapper').css({'height': '68px', 'overflow-y': 'auto'});
   }
   if (data.count < 4) {
    $('div#qtc-barfly-friends-list-wrapper').css({'height': 'auto', 'overflow-y': 'hidden'});
   }
   $('div#qtc-barfly-friends-list-wrapper').html(friends);
   $('div.qtc-bar-user-online-counter').text(data.count);

   // Friends block.
   if (data.count == 0) {
    friends = '<span id="qtc-friends-empty">'+Drupal.t('There are no online friends.')+'</span>';
   }
   if (data.count > 4) {
    $('div#qtc-friends-block-list-wrapper').css({'height': '90px', 'overflow-y': 'auto'});
   }
   if (data.count < 4) {
    $('div#qtc-friends-block-list-wrapper').css({'height': 'auto', 'overflow-y': 'hidden'});
   }
   $('div#qtc-friends-block-list-wrapper').html(friends);
      
   $.each(openBoxes, function(b,item) {
    if (!onlineBoxes[openBoxes[b]]) {
     $('span#qtc-bar-user-stat-online_'+openBoxes[b]).hide();
     $('span#qtc-bar-user-stat-offline_'+openBoxes[b]).css('display', 'block');
     $('div#chatbox_'+openBoxes[b]).addClass('chatbox-user-offline');
     $('div#chatbox_'+openBoxes[b]).removeClass('chatbox-user-online');
     $('#chatbox_'+openBoxes[b]+' .chatboxmessage-offline').remove();
     $("div#chatbox_"+openBoxes[b]+" .chatboxcontent").append('<div class="chatboxmessage-offline"><span class="chatboxmessagefrom">'+Drupal.t('Chat')+':&nbsp;&nbsp;</span><span class="chatboxmessagecontent">'+Drupal.t('User is offline.')+'</span>&nbsp;<span class="chatboxmessagetime">'+messageDate()+'</span></div>');
    }
    else {
     $('span#qtc-bar-user-stat-online_'+openBoxes[b]).css('display', 'block');
     $('span#qtc-bar-user-stat-offline_'+openBoxes[b]).hide();
     $('div#chatbox_'+openBoxes[b]).addClass('chatbox-user-online');
     $('div#chatbox_'+openBoxes[b]).removeClass('chatbox-user-offline');
     $('#chatbox_'+openBoxes[b]+' .chatboxmessage-offline').remove();
    }
   });

   setTimeout('chatHeartbeatFriendlist();', heartbeatFriendlistTime);
 }});
}

function closeChatBox(t_id,f_id) {
 $('div#chatbox_'+t_id).remove();
 $.post(Drupal.settings.qtc.baseUrl + "/qtc/ajax/close", { t_id: t_id, chatbox: f_id} , function(data) {
 });

 reorganizeMinimizedCookie(t_id);

 for (i=0;i<chatBoxes.length;i++) {
  if (chatBoxes[i] == t_id) {
   chatBoxes.splice(i,1);
   chatBoxeslength -= 1;
  }
 }

 restructureChatBoxes();
}

function toggleChatBoxGrowth(t_id,t_un) {
 var newCookie;
 if ($('div#chatbox_'+t_id+' .chatboxcontent').css('display') == 'none') {
  if ($.cookie('chatbox_minimized')) {
   minimizedChatBoxes = $.cookie('chatbox_minimized').split(/\|/);
  }

  newCookie = '';

  for (i=0;i<minimizedChatBoxes.length;i++) {
   if (minimizedChatBoxes[i] == t_id) {
    minimizedChatBoxes.splice(i,1);
   }
  }
    
  newCookie = minimizedChatBoxes.join('|');
  $.cookie('chatbox_minimized', newCookie, { expires: 365, path: '/' });

  $('div#chatbox_'+t_id).removeClass('collapsed');
  $('div#chatbox_'+t_id+' .chatboxsubhead').css('display', 'block');
  $('div#chatbox_'+t_id+' .chatboxcontent').css('display', 'block');
  $('div#chatbox_'+t_id+' .chatboxinput').css('display', 'block');
  $("div#chatbox_"+t_id+" .chatboxcontent").scrollTop($("#chatbox_"+t_id+" .chatboxcontent")[0].scrollHeight);
 }
 else {
  newCookie = t_id;

  if ($.cookie('chatbox_minimized')) {
   newCookie += '|'+$.cookie('chatbox_minimized');
  }
  $.cookie('chatbox_minimized', newCookie, { expires: 365, path: '/' });

  $('div#chatbox_'+t_id).addClass('collapsed');
  $('div#chatbox_'+t_id+' .chatboxsubhead').css('display', 'none');
  $('div#chatbox_'+t_id+' .chatboxcontent').css('display', 'none');
  $('div#chatbox_'+t_id+' .chatboxinput').css('display', 'none');
 }
}

function chatBoxDisplay() {
 var boxes = $.cookie('chatbox_minimized').split(/\|/);

 for (i=0;i<boxes.length;i++) {
  $('div#chatbox_'+boxes[i]+' .chatboxsubhead').css('display', 'none');
  $('div#chatbox_'+boxes[i]+' .chatboxcontent').css('display', 'none');
  $('div#chatbox_'+boxes[i]+' .chatboxinput').css('display', 'none');
 }
}

function reorganizeMinimizedCookie(t_id) {
 var boxes = $.cookie('chatbox_minimized').split(/\|/);

 for (i=0;i<boxes.length;i++) {
  if (boxes[i] == t_id) {
   boxes.splice(i,1);
  }
 }
 newCookie = boxes.join('|');
 $.cookie('chatbox_minimized', newCookie, { expires: 365, path: '/' });
}

function checkChatBoxInputKey(event,chatboxtextarea,t_id,t_un,to_name) {
 var currentBrowser = $.browser.browser();
 var currentBrowserVersion = $.browser.version.string();
 var variableHeight = 18;
 var baseHeight = 18;
 var lowerHeight = '';
 var baseBoxContentHeight = 198;
 var variableBoxContentHeight = crossBoxContentHeight(t_id);

 if(event.keyCode == 13 && event.shiftKey == 0)  {
  message = $(chatboxtextarea).val();
  message = message.replace(/^\s+|\s+$/g,"");

  urn = Drupal.t('Me');
  var mTime = messageDate();

  $(chatboxtextarea).val('');

  $("div#chatbox_"+t_id).focus();

  if (message != '') {
   $.post(Drupal.settings.qtc.baseUrl + "/qtc/ajax/send", {t_id: t_id, to: t_un, to_name: to_name, message: message} , function(data) {
    message = message.replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/\"/g, "&quot;");

    $("div#chatbox_"+t_id+" .chatboxcontent").append('<div class="chatboxmessage"><span class="chatboxmessagefrom">'+urn+':&nbsp;&nbsp;</span><span class="chatboxmessagecontent">'+message+'</span>&nbsp;<span class="chatboxmessagetime">'+mTime+'</span></div>');
    $("div#chatbox_"+t_id+" .chatboxcontent").scrollTop($("div#chatbox_"+t_id+" .chatboxcontent")[0].scrollHeight);
   });

   $(chatboxtextarea).css('height', '18px');
   $(chatboxtextarea).css('overflow' , 'hidden');
   $("div#chatbox_"+t_id+" .chatboxcontent").height(198);
  }
  chatHeartbeatTime = minChatHeartbeat;
  chatHeartbeatCount = 1;

  return false;
 }

 if (crossScrollHeight(chatboxtextarea) > variableHeight) {
  variableHeight = crossScrollHeight(chatboxtextarea);
  variableBoxContentHeight = baseBoxContentHeight - crossScrollHeight(chatboxtextarea) + baseHeight;

  if (crossScrollHeight(chatboxtextarea) > 54) {
   $(chatboxtextarea).css('height', 54 +'px');
   $(chatboxtextarea).css('overflow-y' , 'auto');
   $("div#chatbox_"+t_id+" .chatboxcontent").height(162);
   if (currentBrowser == 'Internet Explorer' && currentBrowserVersion >= 8.0 && currentBrowserVersion < 9) {
    $("div#chatbox_"+t_id+" .chatboxcontent").height(163);
   }
  }
  else {
   $(chatboxtextarea).css('height', variableHeight +'px');
   $("div#chatbox_"+t_id+" .chatboxcontent").height(variableBoxContentHeight);
   if (currentBrowser == 'Internet Explorer' && currentBrowserVersion >= 8.0 && currentBrowserVersion < 9) {
    $("div#chatbox_"+t_id+" .chatboxcontent").height(variableBoxContentHeight + 1);
   }
  }
 }
 if (crossScrollHeight(chatboxtextarea) < variableHeight) {
  lowerHeight = (crossScrollHeight(chatboxtextarea) + 4) - baseHeight;
  variableBoxContentHeight = baseBoxContentHeight - (crossScrollHeight(chatboxtextarea) + 4) + (baseHeight * 2);
  $(chatboxtextarea).css('height', lowerHeight +'px');
  $("div#chatbox_"+t_id+" .chatboxcontent").height(variableBoxContentHeight);

  if (crossScrollHeight(chatboxtextarea) < 54) {
   $(chatboxtextarea).css('overflow' , 'hidden');
  }
 }
 if (crossScrollHeight(chatboxtextarea) == 18) {
  $(chatboxtextarea).css('height', '18px');
  $(chatboxtextarea).css('overflow' , 'hidden');
  $("div#chatbox_"+t_id+" .chatboxcontent").height(198);
 }
}

function crossScrollHeight(elem) {
 var h = elem.scrollHeight;
 var currentBrowser = $.browser.browser();
 var currentBrowserVersion = $.browser.version.string();
  
 if (currentBrowser == 'Internet Explorer' && currentBrowserVersion >= 7.0 && currentBrowserVersion < 8) {
  h += 2;
 }
 if (currentBrowser == 'Internet Explorer' && currentBrowserVersion == 8.0 && currentBrowserVersion < 9) {
  h += 3;
 }
 return h;
}

function crossBoxContentHeight(t_id) {
 var h = $("div#chatbox_"+t_id+" .chatboxcontent").height();
 var currentBrowser = $.browser.browser();
 var currentBrowserVersion = $.browser.version.string();

 if (currentBrowser == 'Internet Explorer' && currentBrowserVersion == 8.0 && currentBrowserVersion < 9) {
  h -= 3;
 }
 return h;
}

function startChatSession() {   
 $.ajax({
  type: "POST",
  url: Drupal.settings.qtc.baseUrl + "/qtc/ajax/data",
  data: "c_id=1",
  cache: false,
  dataType: "json",
  success: function(data) {
   setTimeout('chatHeartbeat();', chatHeartbeatTime);

   $.each(data.items, function(i,item) {
    if (item) {
     var t_id = item.i;
     createChatBox(item.t_id, item.chatuser, item.name, item.items, false, 1);
     // createChatBox(t_id,t_un,t_name,m,t,minimizeChatBox)
     if (item.s == 1) {
      item.f = un;
     }
     if (item.s == 2) {
      $("div#chatbox_"+t_id+" .chatboxcontent").append('<div class="chatboxmessage"><span class="chatboxinfo">'+item.m+'</span></div>');
     }
     else {
      if (item.f == data.un) {
       item.fn = Drupal.t('Me');
      }
      $("div#chatbox_"+t_id+" .chatboxcontent").append('<div class="chatboxmessage"><span class="chatboxmessagefrom">'+item.fn+':&nbsp;&nbsp;</span><span class="chatboxmessagecontent">'+item.m+'</span></div>');
     }
    }
   });

   setTimeout('chatHeartbeatFriendlist();', Drupal.settings.qtc.minHeartbeat);
  }
 });
}

function toggleTime() {
 $('a.messagetime-toggle').click( function() {
  var cu = $(this).parent().parent().attr('id');
  cu = cu.substring(8);

  if ($('div#chatbox_'+cu+' .messagetime-toggle').attr('ts') == 'none') {
   $('div#chatbox_'+cu+' .chatboxmessagetime').hide();
   $('div#chatbox_'+cu+' .messagetime-toggle').attr({ts: 'show'});
  }
  else if ($('div#chatbox_'+cu+' .messagetime-toggle').attr('ts') == 'show') {
   $('div#chatbox_'+cu+' .chatboxmessagetime').show();
   $('div#chatbox_'+cu+' .messagetime-toggle').attr('ts', 'none');
  }
 });
}

function goOffOnline(op, id) {
 $.ajax({
  type: "POST",
  url: Drupal.settings.qtc.baseUrl + "/qtc/ajax/set-online-status",
  data: "os_act="+op+"&id="+id,
  success: function() {
   if (op == 0) {
    // QTC bar flying content option.
    $('#qtc-barfly-online-indicator-on').hide();
    $('#qtc-barfly-online-indicator-off').show();
    $('#qtc-bar-online-indicator').removeClass('qtc-user-online');
    $('#qtc-bar-online-indicator').addClass('qtc-user-offline');
    // Friends block.
    $('#qtc-friends-block-onoffline-wrapper #qtc-friends-block-toggler-on').hide();
    $('#qtc-friends-block-onoffline-wrapper #qtc-friends-block-toggler-off').show();
    // Toggler block.
    $('#qtc-toggler-block-onoffline-wrapper #qtc-toggler-block-toggler-on').hide();
    $('#qtc-toggler-block-onoffline-wrapper #qtc-toggler-block-toggler-off').show();
   }
   if (op == 1) {
    // QTC bar flying content option.
    $('#qtc-barfly-online-indicator-on').show();
    $('#qtc-barfly-online-indicator-off').hide();
    $('#qtc-bar-online-indicator').addClass('qtc-user-online');
    $('#qtc-bar-online-indicator').removeClass('qtc-user-offline');
    // Friends block.
    $('#qtc-friends-block-onoffline-wrapper #qtc-friends-block-toggler-on').show();
    $('#qtc-friends-block-onoffline-wrapper #qtc-friends-block-toggler-off').hide();
    // Toggler block.
    $('#qtc-toggler-block-onoffline-wrapper #qtc-toggler-block-toggler-on').show();
    $('#qtc-toggler-block-onoffline-wrapper #qtc-toggler-block-toggler-off').hide();
   }

   // User account; edit online status form.
   $('#edit-status-status selected').remove();
   $('#edit-status-status').val(op);
  }
 });

 $.sleep ( 3, function() {
 });
}

function deleteCookie(cid) {
 $.cookie(cookieName, null);
}

function setCookie(cid) {
 $.cookie(cookieName, cid, { expires: 1 });
}

function messageDate(format,convert) {
 var mTime = '';
 //var date = new Date();
// if (convert) {
//  date = Date(convert * 1000);
//  date = date.setTime;
// }
 var day = date.getDate();
 var month = date.getMonth() + 1;
 var year = date.getFullYear();
 var hour = date.getHours();
 var minute = date.getMinutes();
 var second = date.getSeconds();
 var monthname = new Array(Drupal.t('January'), Drupal.t('February'), Drupal.t('March'), Drupal.t('April'), Drupal.t('May'), Drupal.t('June'), Drupal.t('July'), Drupal.t('August'), Drupal.t('September'), Drupal.t('October'), Drupal.t('November'), Drupal.t('December'));

 if (minute < 10) {
  minute = '0'+minute;
 }
 if (format == 'short' || !format) {
  mTime = hour+':'+minute;
 }
 if (format == 'long') {
  mTime = hour+':'+minute+' '+monthname[month]+' '+day;
 }

 return mTime;
}

function numComparisonAsc(a, b)	{
 return a-b;
}

(function($) {
 $.fn.found = function(fFunction) {
  if(this.length) {
   fFunction.call(this);
  }
 };
})(jQuery);

(function($) {
 $.fn.notfound = function(nfFunction) {
  if(!this.length) {
   nfFunction.call(this);
  }
 };
})(jQuery);

/**
 * Sleep function.
 *
 * Usage:
 * $.sleep ( 3, function() {
 *  alert ('I slept for 3 seconds.');
 * });
 */
(function($) {
 var _sleeptimer;
 $.sleep = function( time2sleep, callback ) {
  $.sleep._sleeptimer = time2sleep;
  $.sleep._cback = callback;
  $.sleep.timer = setInterval('$.sleep.count()', 1000);
 }
 $.extend ($.sleep, {
  current_i: 1,
  _sleeptimer: 0,
  _cback: null,
  timer: null,
  count: function() {
   if ( $.sleep.current_i === $.sleep._sleeptimer ) {
    clearInterval($.sleep.timer);
    $.sleep._cback.call(this);
   }
   $.sleep.current_i++;
  }
 });
})(jQuery);

(function($) {
 $.fn.getLines = function (element) {
  return $(this).val().split("\n").length;
 }
})(jQuery);
